"use strict";
this.name	= "separatedlasers-conditions";
this.author	= "Norby";
this.copyright	= "2016 Norby";
this.description= "Lasers will not heat up faster if there is at least 30m space between multiple mounts";
this.licence	= "CC BY-NC-SA 4.0";

//condition script
this.allowAwardEquipment = function(equipment, ship, context)
{
        if( !this.$SL ) { //save worldScript pointers into faster variables
                this.$SL = worldScripts.separatedlasers; //read once only
                this.$SG = worldScripts.snipergun;
                this.$LC = worldScripts.lasercannons;
        }

        // OXP hook to allow stations to forbid specific equipment
        if (context == "purchase" && player.ship.dockedStation && player.ship.dockedStation.scriptInfo["oolite-barred-equipment"])
        {
                if (player.ship.dockedStation.scriptInfo["oolite-barred-equipment"].indexOf(equipment) != -1)
                {
                        return false;
                }
        }

        // OXP hook to allow ships to forbid specific "available to all" equipment
        if (ship.scriptInfo && ship.scriptInfo["oolite-barred-equipment"] && ship.scriptInfo["oolite-barred-equipment"].indexOf(equipment) != -1)
        {
                return false;
        }

//      player.consoleMessage( eqKey+" "+ship+" "+context );//debug


        //check for multiple mounts
        var m = this.$SL._getMultiLevel(equipment);
        //chech for a proper multiple mount on this ship
        if( m > 0 && ship.weaponPositionForward.length != m
                && ship.weaponPositionAft.length != m
                && ship.weaponPositionPort.length != m
                && ship.weaponPositionStarboard.length != m ) {

                if( m < 5 ) return false; //dual, triple and quad lasers need exact match in mounts

                if( ship.weaponPositionForward.length < m //allow broadside lasers at and over 5 mounts
                        && ship.weaponPositionAft.length < m
                        && ship.weaponPositionPort.length < m
                        && ship.weaponPositionStarboard.length < m )
                        return false;
        }
        //log(this.name, ship.name+" "+equipment+" "+context+" m="+m); //debug

        //Sniper Gun is checked in its own script (need specific subEntity on the ship)
        if( equipment.indexOf("EQ_WEAPON_CANNON_SNIPER_GUN") > -1
                || equipment.indexOf("EQ_WEAPON_CANNON_HEAVY_SNIPER_GUN") > -1 ) {
                var w = this.$SG;
                if( !w ) return false;
                return( w._allowAwardSniperGun(equipment, ship, context, w) );
        }

        //exclude separated laser cannons when Laser Cannons OXP is not installed
        if( !this.$LC && ( equipment.indexOf("EQ_WEAPON_CANNON_2_") > -1
                || equipment.indexOf("EQ_WEAPON_CANNON_4_") > -1
                || equipment.indexOf("EQ_WEAPON_CANNON_5_") > -1
                || equipment.indexOf("EQ_WEAPON_CANNON_7_") > -1
                || equipment.indexOf("EQ_WEAPON_CANNON_11_") > -1
                || equipment.indexOf("EQ_WEAPON_CANNON_12_") > -1  ) )
                return false;

        //Eco Artillery and Twin Cannons need as large ship as an Anaconda
        if( ship.mass < 400000 && equipment.indexOf("EQ_WEAPON_CANNON_EA") > -1
                || equipment.indexOf("EQ_WEAPON_CANNON_5_") > -1
                || equipment.indexOf("EQ_WEAPON_CANNON_12_") > -1 ) return false;

        //Eco Reactor, Vulcan Cannon and Plasma Web need as large ship as a Python
        if( ship.mass < 250000 &&
                (  equipment.indexOf("EQ_WEAPON_ECO_REACTOR") > -1
                || equipment.indexOf("EQ_WEAPON_CANNON_7_") > -1
                || equipment.indexOf("EQ_WEAPON_CANNON_9_") > -1 ) ) return false;

        //Eco Laser, Mini Cannon and Mini Plasma Ray fit into escort ships from 30t
        if( ship.mass <= 30000 &&
                (  equipment.indexOf("EQ_WEAPON_ECO_LASER") > -1
                || equipment.indexOf("EQ_WEAPON_CANNON_2_") > -1
                || equipment.indexOf("EQ_WEAPON_CANNON_8_") > -1 ) ) return false;

        //Other cannons for large ships only like Cobra Mark III
        if( equipment.indexOf("EQ_WEAPON_CANNON") > -1 && ship.mass < 130000 ) return false;

        return true;
}
